import { defineStore } from 'pinia'

export const useConfigStore = defineStore('config', () => {
  class Instance {
    constructor(instance) {
      this.checked = instance.checked
      this.name = instance.name
      this.path = instance.path
    }
  }

  class Config {
    constructor(conf) {
      // 整体 Total
      this.page = conf.page
      this.is_already_show_doc = conf.is_already_show_doc
      // 更新代码 UpdatePart
      this.branch = conf.branch
      this.mirror = conf.mirror
      // 启动程序 LaunchPart
      this.instances = []
      this.is_show_log = conf.is_show_log
      Object.assign(this, conf)
    }
  }

  const config = reactive({})

  async function load_config() {
    const conf = await pywebview.api.load_config()
    Object.assign(config, new Config(conf))
    console.log('响应式配置已更新', config)
  }

  watch(
    config,
    () => {
      pywebview.api.save_config(config)
    },
    { deep: true }
  )

  return {
    load_config,
    config
  }
})
